#pragma once

template <class Type, unsigned int Size>
struct FixedArray {
    Type arr[Size];
    inline Type &operator[] (const int i) { return arr[i]; }
    inline const Type &operator[] (const int i) const { return arr[i]; }

    inline bool operator== (const FixedArray<Type, Size> &other) const {
        for (int i = 0; i < (int)Size; i++)
            if (arr[i] != other.arr[i])
                return false;
        return true;
    }
    inline bool operator!= (const FixedArray<Type, Size> &other) const {
        return !(*this == other);
    }
};

typedef FixedArray<double, 2> Range;

/*
QDebug operator<<(QDebug dbg, const Range &r)
{
    dbg << r[0] << r[1];
    return dbg;
}
*/
