#pragma once

#include <QWidget>

class QGestureEvent;
class DeflectWid : public QWidget
{
    Q_OBJECT

public slots:
    void setXY(float x, float y);
    void setInt(float i);
    void setMag(QString Mag_new);
    void setDfl(QString Dfl_new);
    void setLfl(QString Lfl_new);
    void setZpos(float Zpos_new);
    void setTuningFork(bool);
    void setFbscanner(int value);
    void setSTM(bool);

signals:
    void doubleClicked();

protected:
    bool event(QEvent *);
    void paintEvent(QPaintEvent *event);
    bool gestureEvent(QGestureEvent *event);

private:
    QPixmap pixmap;
    QPixmap TuneFork;

    bool bSnotra;
    bool bSTM;

    QFont font;
    int FBscanner;

    const static int FONT_SCALE = 12;
    const static int SPOT_SCALE = 2;
    float X, Y;
    QString MAG, DFL, LFL;
    float Zpos;
    float intens;
    void mouseDoubleClickEvent(QMouseEvent *Event);

public:
    DeflectWid();
};
