#pragma once

#include <QLayout>

void addDelimeterV(QLayout *lay, short size);
void addDelimeterH(QLayout *lay, short size);

class VFlowLayout : public QLayout
{
public:
    VFlowLayout(QWidget *parent = 0);
    ~VFlowLayout();

    void addItem(QLayoutItem *item);
    void insertWidget(int pos, QWidget *wid);
    int count() const;
    QLayoutItem *itemAt(int index) const;
    QLayoutItem *takeAt(int index);

    void setGeometry(const QRect &rect);
    QSize minimumSize() const;
    QSize maximumSize() const;
    QSize sizeHint() const;
    Qt::Orientations expandingDirections() const;
    bool hasHeightForWidth() const;
    int	heightForWidth(int w) const;

    int spaceX;
    int spaceY;

protected:
    virtual int doLayout(const QRect &rect, bool testOnly) const;
    QList<QLayoutItem *> itemList;
};

class HFlowLayout : public VFlowLayout
{
public:
    HFlowLayout(QWidget *parent = 0);

    void setGeometry(const QRect &rect);
    QSize minimumSize() const;
    Qt::Orientations expandingDirections() const;
    bool hasHeightForWidth() const;

protected:
    int doLayout(const QRect &rect, bool testOnly) const;
    int prev_height;
};
