#pragma once

#include <qwt_slider.h>

class QGestureEvent;
class NSTSlider : public QwtSlider
{
    Q_OBJECT
public:
    NSTSlider(double min, double max, int decimals = 0, QWidget *parent = 0, bool vertical = false);

    double fixedValue(double value) const;

    double minV, maxV;
    double stepV;

    QPoint pos;
    int prevZoom;
    int pressed;

    QVector<QPair<double, QColor> > marks;

signals:
    void newValue();
    void newValue(int);
    void newValue(double);

public slots:
    void setNewValue();

public slots:
    void setValue(double new_value);
    void stepBy(int steps) { setValue(value + steps * stepV); setNewValue(); }
    void stepUp() { stepBy(1); }
    void stepDown() { stepBy(-1); }
    void pageUp() { stepBy(10); }
    void pageDown() { stepBy(-10); }

public slots:
    void slPressed() { pressed = 1; }
    void slUnPressed() { pressed = 0; }
    void setMainRangeAndStep(double min, double max, double step);

signals:
    void rangeStepChanged(double min, double max, double step);

protected:
    bool event(QEvent *);
    void mousePressEvent(QMouseEvent *);
    void mouseMoveEvent(QMouseEvent *);
    void wheelEvent(QWheelEvent *);
    void mouseDoubleClickEvent(QMouseEvent *);
    bool gestureEvent(QGestureEvent *event);
    void resizeEvent(QResizeEvent *);

    //void drawSlider ( QPainter *, const QRect & ) const;
    void drawHandle( QPainter *, const QRect &, int pos ) const;

};
