#pragma once

#include <QLayout>

//uses minimumSize() for aspect ratio
class RatioLayout : public QLayout
{
public:
    RatioLayout(QWidget *parent = 0);
    ~RatioLayout();

    void addItem(QLayoutItem *item);
    int count() const;
    QLayoutItem *itemAt(int index) const;
    QLayoutItem *takeAt(int index);

    void setGeometry(const QRect &rect);
    QSize minimumSize() const;
    QSize maximumSize() const;
    QSize sizeHint() const;
    Qt::Orientations expandingDirections() const;

protected:
    QLayoutItem *item;
};
