#pragma once

#define NOMINMAX //FUCK MSVC LIBRARY
#include <QGLWidget>
#ifndef NO_GLES_3D
#include <QGLFunctions>
#include <QGLShaderProgram>
#endif
#include <QMatrix4x4>

class T3dViewer : public QGLWidget
#ifndef NO_GLES_3D
        , protected QGLFunctions
#endif
{
public:
    T3dViewer(QWidget *parent = 0);
    ~T3dViewer();
    void initializeGL();
    void resizeGL(int w, int h);
    void paintGL();
    void drawGuiTexture(int texture, QRectF rect);

    void updateData(float *z_values, int nx, int ny, float k = 1.0f);
    void updateTexture(QImage texture);
    void setTitle(QString title, QFont font = QFont());
    void setAxisTitle(int idx, QString title, QFont font = QFont());
    QImage textureFromString(QString string, QFont font);

    void mousePressEvent(QMouseEvent *e);
    void mouseReleaseEvent(QMouseEvent *);
    void mouseMoveEvent(QMouseEvent *e);
    void wheelEvent(QWheelEvent *e);

    bool pressed;
    int mousemode;
    QPointF old;
    double scale, z_scale, xyaspect;
    double x_rot, y_rot, z_rot;
    double _x_rot, _y_rot, _z_rot;
    double x_pos, y_pos, z_pos;
    double _x_pos, _y_pos, _z_pos;

    int iaxistexture[3];
    QRectF axisrect[3];

    int ititletexture;
    QRectF titlerect;

    QColor bgColor;
    QColor fgColor;

    bool showAxes;
    bool invertY;

    int itexture;
#ifdef NO_GLES_3D
    int m_glListId;
    int m_axesLists;
#else
    int m_glVboId, m_glIndicesId, vboSize;
    int m_glBoxIndices;
    int m_glFSQuadIndices;

    QGLShaderProgram program;
    QGLShaderProgram textprogram;
#endif
    QMatrix4x4 projection;
};
