#ifndef INSPECTR_HPP
#define INSPECTR_HPP

#include "ccd/i_spectr.hpp"
#include <QObject>
#include <QMutex>

class INspectr : public QObject, public I_SPECTR
{
    Q_OBJECT
public slots:

public:
    INspectr(void *hwnd = 0); //stored for init/lib use

    bool initialize(int num);
    bool shutdown();

    QString getName();
    bool isReady();

    bool preparePixelWl(double pixelsize, int nx, int central_pixel);
    double getPixelWl(int pixel_idx);

    bool setWl(double wl, bool reset = false);
    double getWl();
    double getDispersion();

    int getGratingCount();
    QString getGratingName(int idx);
    bool setActiveGrating(int idx, bool reset = false);
    int getActiveGrating();

    bool setSlitWidth(int port, double width);
    double getSlitWidth(int port);

    bool setPortPosition(int port, int idx);
    int getPortPosition(int port);

    QMutex guiThreadLock;
    void *hwnd;
    int cp;
    double pxsize, cwl;
};

#endif // INSPECTR_HPP
