#pragma once

#include <QWidget>
#include "edit.hpp"

class QCheckBox;
class QTreeWidget;
class QComboBox;
class QTreeWidgetItem;
class QSettings;
class TOptionsWindow: public QWidget
{
    Q_OBJECT
public:
    TOptionsWindow(QWidget *parent);

public slots:
    void selectCustomTR();
    void Show();
    void Apply();
    void BFont();
    void BData();
    void configEdited(QTreeWidgetItem *item, int column);
    void editorResize();

protected:
    void addConfig(QSettings &settings, QString file, QString path, QVariant default_val, QString comment = "");
    void addConfig(QSettings &settings, QString file, QString path, QString comment = "");
    void addConfig(QString file, QString path, QVariant default_val, QString comment = "");
    void addConfig(QString file, QString path, QString comment = "");

    QTreeWidget *editor;
    QMap<QString, QTreeWidgetItem *> items;

    QComboBox *Ctranslation;
    Edit *szbox;
    Edit *as_time;

    QFont font;
    QString datadir;

    QCheckBox *CBgwy_imp;
    QCheckBox *CBremote_net;
    QCheckBox *CBremote_pwd;
    QCheckBox *CBremote_log;
    QCheckBox *CBremote_guest;

    Edit *remote_port;
    QLineEdit *remote_pwd;

    QCheckBox *ch1;
    QCheckBox *ch2;
    QCheckBox *ch3;
    QCheckBox *ch4;
    QCheckBox *ch5;
    QCheckBox *ch6;
    QCheckBox *ch8;
    QCheckBox *ch9;

    QCheckBox *ch03;
    QCheckBox *ch04;
    QCheckBox *ch041;
    QCheckBox *ch05;
    QCheckBox *ch090;
    QCheckBox *ch091;
    QCheckBox *ch092;

    QCheckBox *ch11;
    QCheckBox *ch12;
    QCheckBox *ch13;
    QCheckBox *ch14;
    QCheckBox *ch15;
    QCheckBox *ch16;
    QCheckBox *ch17;
    QCheckBox *ch18;

};
